<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

// No direct access
defined('_JEXEC') or die;

/**
 * Pdjx helper.
 */
class PdjxHelper
{
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($vName = '')
	{
		JSubMenuHelper::addEntry(
			JText::_('COM_PDJX_TITLE_FILES'),
			'index.php?option=com_paiddownloadsjx&view=files',
			$vName == 'files'
		);
		JSubMenuHelper::addEntry(
			JText::_('COM_PDJX_TITLE_TRANSACTIONS'),
			'index.php?option=com_paiddownloadsjx&view=transactions',
			$vName == 'transactions'
		);

	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getActions()
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		$assetName = 'com_paiddownloadsjx';

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action, $user->authorise($action, $assetName));
		}

		return $result;
	}
}
