<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

defined('JPATH_BASE') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Supports an HTML select list of categories
 */
class JFormFieldCurrencies extends JFormFieldList
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'Currencies';

/**
	 * Method to get the field options.
	 *
	 * @return  array  The field option objects.
	 *
	 * @since   11.1
	 */
	protected function getOptions()
	{
		// Initialize variables.
	
		$items = array();
		
		$items[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select Currency' ) .' -', 'value', 'text' );
		
		$cc= array(
			"Australian Dollar"=>"AUD",
			"Brazilian Real"=>"BRL", 
			"Canadian Dollar"=>"CAD",
			"Czech Koruna"=>"CZK",
			"Danish Krone"=>"DKK", 
			"Euro"=>"EUR", 
			"Hong Kong Dollar"=>"HKD",
			"Hungarian Forint"=>"HUF",
			"Israeli New Sheqel"=>"ILS", 
			"Japanese Yen"=>"JPY", 
			"Malaysian Ringgit"=>"MYR", 
			"Mexican Peso"=>"MXN", 
			"Norwegian Krone"=>"NOK", 
			"New Zealand Dollar"=>"NZD", 
			"Philippine Peso"=>"PHP",
			"Polish Zloty"=>"PLN",
			"Pound Sterling"=>"GBP", 
			"Singapore Dollar"=>"SGD", 
			"Swedish Krona"=>"SEK", 
			"Swiss Franc"=>"CHF", 
			"Taiwan New Dollar"=>"TWD", 
			"Thai Baht"=>"THB",
			"Turkish Lira" => "TRY",
			"U.S. Dollar"=>"USD", 			
		);
		
		foreach ($cc as $v=>$k) {
			$items[] = JHTML::_('select.option', $k, $v);
		}

		return $items;
	}
}