<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

defined('JPATH_BASE') or die;

JFormHelper::loadFieldClass('filelist');

/**
 * Supports an HTML select list of categories
 */
class JFormFieldPdjxfilelist extends JFormFieldList
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	public $type = 'Pdjxfilelist';

/**
	 * Method to get the field options.
	 *
	 * @return  array  The field option objects.
	 *
	 * @since   11.1
	 */
	protected function getOptions()
	{

        $db = JFactory::getDbo();

        $query = $db->getQuery(true);

        $query->select($db->quoteName(['id', 'itemname']));
        $query->from($db->quoteName('#__pdjx_files'));
        $query->order('ordering ASC');

        $db->setQuery($query);

        $results = $db->loadObjectList();
        $options = [];
        if (count($results)) {
            foreach ($results as $item) {
                $options[(int)$item->id] = $item->itemname;
            }
        }

		return $options;
	}
}