<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

defined('JPATH_BASE') or die;

JFormHelper::loadFieldClass('filelist');

/**
 * Supports an HTML select list of categories
 */
class JFormFieldPdjxversionslist extends JFormFieldList
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	public $type = 'Pdjxversionslist';

/**
	 * Method to get the field options.
	 *
	 * @return  array  The field option objects.
	 *
	 * @since   11.1
	 */
	protected function getOptions()
	{
        if (isset($_GET['id'])) {
            $fileid = $_GET['id'];
            $db = JFactory::getDbo();

            $query = $db->getQuery(true);

            $query->select($db->quoteName(['id', 'version']));
            $query->from($db->quoteName('#__pdjx_versions'));
            $query->where($db->quoteName('fileid') .'='. $fileid);
            $query->where($db->quoteName('state') .'='. 1);
            $query->order('version ASC');

            $db->setQuery($query);

            $results = $db->loadObjectList();
            $options = [
                0 => JText::_('COM_PDJX_FORM_ITEM_1_FILE_VERSION')
            ];
            if (count($results)) {
                foreach ($results as $item) {
                    $options[(int)$item->id] = $item->version;
                }
            }
        } else {
            $options = [
                0 => JText::_('COM_PDJX_FORM_ITEM_1_FILE_VERSION')
            ];
        }

		return $options;
	}
}