<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

// No direct access
defined('_JEXEC') or die;

if(!class_exists('PaiddownloadsjxController'))require_once JPATH_BASE.'components/com_paiddownloadsjx/controller.php';

/**
 * File controller class.
 */
class PaiddownloadsjxControllerVersions extends PaiddownloadsjxController
{

	public function getButton($id){
		//echo "<pre>";print_r($this->paths);echo "</pre>";
		$view = $this->getView('File', 'html');
		$mdl=$this->getModel('File', 'PaiddownloadsjxModel');
		//$mdl->_ID=$id;
		$mdl->getData($id);
		$view->setModel($mdl, true);
		$view->addTemplatePath(JPATH_SITE.'/components/com_paiddownloadsjx/views/file/tmpl');
		$view->setLayout('button');
		//echo "<pre>bbb ";print_r($mdl->getState());echo "</pre>";
		return $view->loadTemplate();
		
	}
	/**
	 * Method to check out an item for editing and redirect to the edit form.
	 *
	 * @since	1.6
	 */
	public function edit()
	{
		$app			= JFactory::getApplication();

		// Get the previous edit id (if any) and the current edit id.
		$previousId = (int) $app->getUserState('com_paiddownloadsjx.edit.file.id');
		$editId	= JFactory::getApplication()->input->getInt('id', null, 'array');

		// Set the user id for the user to edit in the session.
		$app->setUserState('com_paiddownloadsjx.edit.file.id', $editId);

		// Get the model.
		$model = $this->getModel('File', 'PaiddownloadsjxModel');

		// Check out the item
		if ($editId) {
            $model->checkout($editId);
		}

		// Check in the previous user.
		if ($previousId) {
            $model->checkin($previousId);
		}

		// Redirect to the edit screen.
		$this->setRedirect(JRoute::_('index.php?option=com_paiddownloadsjx&view=fileform&layout=edit', false));
	}

	/**
	 * Method to save a user's profile data.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function save()
	{
		// Check for request forgeries.
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		// Initialise variables.
		$app	= JFactory::getApplication();
		$model = $this->getModel('File', 'PaiddownloadsjxModel');

		// Get the user data.
		$data = JFactory::getApplication()->input->get('jform', array(), 'array');

		// Validate the posted data.
		$form = $model->getForm();
		if (!$form) {
			JError::raiseError(500, $model->getError());
			return false;
		}

		// Validate the posted data.
		$data = $model->validate($form, $data);

		// Check for errors.
		if ($data === false) {
			// Get the validation messages.
			$errors	= $model->getErrors();

			// Push up to three validation messages out to the user.
			for ($i = 0, $n = count($errors); $i < $n && $i < 3; $i++) {
				if ($errors[$i] instanceof Exception) {
					$app->enqueueMessage($errors[$i]->getMessage(), 'warning');
				} else {
					$app->enqueueMessage($errors[$i], 'warning');
				}
			}

			// Save the data in the session.
			$app->setUserState('com_paiddownloadsjx.edit.file.data', $data);

			// Redirect back to the edit screen.
			$id = (int) $app->getUserState('com_paiddownloadsjx.edit.file.id');
			$this->setRedirect(JRoute::_('index.php?option=com_paiddownloadsjx&view=file&layout=edit&id='.$id, false));
			return false;
		}

		// Attempt to save the data.
		$return	= $model->save($data);

		// Check for errors.
		if ($return === false) {
			// Save the data in the session.
			$app->setUserState('com_paiddownloadsjx.edit.file.data', $data);

			// Redirect back to the edit screen.
			$id = (int)$app->getUserState('com_paiddownloadsjx.edit.file.id');
			$this->setMessage(JText::sprintf('Save failed', $model->getError()), 'warning');
			$this->setRedirect(JRoute::_('index.php?option=com_paiddownloadsjx&view=file&layout=edit&id='.$id, false));
			return false;
		}

            
        // Check in the profile.
        if ($return) {
            $model->checkin($return);
        }
        
        // Clear the profile id from the session.
        $app->setUserState('com_paiddownloadsjx.edit.file.id', null);

        // Redirect to the list screen.
        $this->setMessage(JText::_('Item saved successfully'));
        $menu = & JSite::getMenu();
        $item = $menu->getActive();
        $this->setRedirect(JRoute::_($item->link, false));

		// Flush the data from the session.
		$app->setUserState('com_paiddownloadsjx.edit.file.data', null);
	}
    
    
    function cancel() {
		$menu = & JSite::getMenu();
        $item = $menu->getActive();
        $this->setRedirect(JRoute::_($item->link, false));
    }
    
	public function remove()
	{
		// Check for request forgeries.
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		// Initialise variables.
		$app	= JFactory::getApplication();
		$model = $this->getModel('File', 'PaiddownloadsjxModel');

		// Get the user data.
		$data = JFactory::getApplication()->input->get('jform', array(), 'array');

		// Validate the posted data.
		$form = $model->getForm();
		if (!$form) {
			JError::raiseError(500, $model->getError());
			return false;
		}

		// Validate the posted data.
		$data = $model->validate($form, $data);

		// Check for errors.
		if ($data === false) {
			// Get the validation messages.
			$errors	= $model->getErrors();

			// Push up to three validation messages out to the user.
			for ($i = 0, $n = count($errors); $i < $n && $i < 3; $i++) {
				if ($errors[$i] instanceof Exception) {
					$app->enqueueMessage($errors[$i]->getMessage(), 'warning');
				} else {
					$app->enqueueMessage($errors[$i], 'warning');
				}
			}

			// Save the data in the session.
			$app->setUserState('com_paiddownloadsjx.edit.file.data', $data);

			// Redirect back to the edit screen.
			$id = (int) $app->getUserState('com_paiddownloadsjx.edit.file.id');
			$this->setRedirect(JRoute::_('index.php?option=com_paiddownloadsjx&view=file&layout=edit&id='.$id, false));
			return false;
		}

		// Attempt to save the data.
		$return	= $model->delete($data);

		// Check for errors.
		if ($return === false) {
			// Save the data in the session.
			$app->setUserState('com_paiddownloadsjx.edit.file.data', $data);

			// Redirect back to the edit screen.
			$id = (int)$app->getUserState('com_paiddownloadsjx.edit.file.id');
			$this->setMessage(JText::sprintf('Delete failed', $model->getError()), 'warning');
			$this->setRedirect(JRoute::_('index.php?option=com_paiddownloadsjx&view=file&layout=edit&id='.$id, false));
			return false;
		}

            
        // Check in the profile.
        if ($return) {
            $model->checkin($return);
        }
        
        // Clear the profile id from the session.
        $app->setUserState('com_paiddownloadsjx.edit.file.id', null);

        // Redirect to the list screen.
        $this->setMessage(JText::_('Item deleted successfully'));
        $menu = & JSite::getMenu();
        $item = $menu->getActive();
        $this->setRedirect(JRoute::_($item->link, false));

		// Flush the data from the session.
		$app->setUserState('com_paiddownloadsjx.edit.file.data', null);
	}
    
    
}