<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

defined('_JEXEC') or die;

abstract class PdjxHelper
{
    public static function extract_zip_to($filename, $path_to_extract) {
        $zip = new ZipArchive;
        if ($zip->open($filename) !== TRUE)
            return new Exception("File doesn't exist");
        if (!file_exists($path_to_extract))
            mkdir($path_to_extract);
        $zip->extractTo($path_to_extract);
        $zip->close();
    }

    public static function zip_folder($zip_file, $folder_path) {
        $zip = New ZipArchive();
        if ($zip->open($zip_file, ZipArchive::CREATE | ZipArchive::OVERWRITE) === TRUE) {
            $files = new RecursiveIteratorIterator(
                new RecursiveDirectoryIterator($folder_path),
                RecursiveIteratorIterator::LEAVES_ONLY
            );

            foreach ($files as $name => $file)
            {
                $filePath = $file->getRealPath();
                if (strpos($filePath, '__MACOSX') === false) {
                    $relativePath = substr($filePath, strlen($folder_path) + 1);
                    // Skip directories (they would be added automatically)
                    if (!$file->isDir()) {
                        // Get real and relative path for current file


                        // Add current file to archive
                        $zip->addFile($filePath, $relativePath);
                    } else {
                        $zip->addEmptyDir($relativePath);
                    }
                }
            }

            $zip->close();
        }
    }

    public static function append_to_xml_update_URL($type, $path, $content) {
        $xml_path = static::find_folder($path);
        $xml_path = static::find_xml($xml_path);

        $xml = file_get_contents($xml_path);

            $content =
            '    <updateservers>
        <server type="extension" name="Joomla! Update Component Update Site">'. $content .'</server>
    </updateservers>
';

        $pos = strpos($xml, '</updateservers>');
        if ($pos !== false) {
            $first = substr($xml, 0, strpos($xml, '<updateservers>'));
            $last = substr($xml, strpos($xml, '</updateservers>') + 16);
            $xml = $first . $content . $last;
        } else {
            $pos = strpos($xml, '</extension>');
            $first = substr($xml, 0, $pos);
            $last = substr($xml, $pos);
            $xml = $first . $content . $last;
        }

        file_put_contents($xml_path, $xml);
    }

    public static function find_xml($path) {
        foreach (scandir($path) as $result) {
            if ($result === '.' or $result === '..') continue;

            if (is_file($path.DIRECTORY_SEPARATOR.$result) && strpos($path.DIRECTORY_SEPARATOR.$result, '.xml') !== false) {
                return $path.DIRECTORY_SEPARATOR.$result;
                break;
            }
        }
    }

    public static function find_folder($path) {
        $new_path = $path;
        foreach (scandir($path) as $result) {
            if ($result === '.' or $result === '..' or $result === '__MACOSX') continue;

            if (is_dir($path . '/' . $result)) {
                $new_path = $path.DIRECTORY_SEPARATOR.$result;
            }
        }

        return $new_path;

    }

    public static function delete_directory($dirname) {
        if (is_dir($dirname))
            $dir_handle = opendir($dirname);
        if (!$dir_handle)
            return false;
        while($file = readdir($dir_handle)) {
            if ($file != "." && $file != "..") {
                if (!is_dir($dirname."/".$file))
                    unlink($dirname."/".$file);
                else
                    PdjxHelper::delete_directory($dirname.'/'.$file);
            }
        }
        closedir($dir_handle);
        rmdir($dirname);
        return true;
    }

	function readfile_chunked($filename,$retbytes=true)
    {
   		$chunksize = 1*(1024*1024); // how many bytes per chunk
   		$buffer = '';
   		$cnt =0;
   		$handle = fopen($filename, 'rb');
   		if ($handle === false) {
       		return false;
   		}
   		while (!feof($handle)) {
       		$buffer = fread($handle, $chunksize);
       		echo $buffer;
			@ob_flush();
			flush();
       		if ($retbytes) {
           		$cnt += strlen($buffer);
       		}
   		}
       $status = fclose($handle);
   	   if ($retbytes && $status) {
       		return $cnt; // return num. bytes delivered like readfile() does.
   		}
   		return $status;
	}
	
	public static function setCtype ($file_extension) {
		//This will set the Content-Type to the appropriate setting for the file
		switch( $file_extension ) {
			 case "pdf": $ctype="application/pdf"; break;
		     case "exe": $ctype="application/octet-stream"; break;
		     case "zip": $ctype="application/zip"; break;
		     case "doc": $ctype="application/msword"; break;
		     case "xls": $ctype="application/vnd.ms-excel"; break;
		     case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
		     case "gif": $ctype="image/gif"; break;
		     case "png": $ctype="image/png"; break;
		     case "jpeg":
		     case "jpg": $ctype="image/jpg"; break;
		     case "mp3": $ctype="audio/mpeg"; break;
		     case "wav": $ctype="audio/x-wav"; break;
		     case "mpeg":
		     case "mpg":
		     case "mpe": $ctype="video/mpeg"; break;
		     case "mov": $ctype="video/quicktime"; break;
		     case "avi": $ctype="video/x-msvideo"; break;
		     //The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
		     case "php":
		     case "htm":
		     case "html": if ($downpath) die("<b>Cannot be used for ". $file_extension ." files!</b>");
		     default: $ctype="application/force-download";
		}
		return $ctype;

	}

	
////// PDT //////

	public static function validate_PDT(& $item, & $keyarray, & $msg){
				JLog::add('funcion validate(& $item)',JLog::DEBUG,'pdjx');	
	
		$cnf = JComponentHelper::getParams('com_paiddownloadsjx');


		if ($item->testmode == 1) {
		 	$auth_token = $cnf->get('test_pptoken');
		 	$paypal = "www.sandbox.paypal.com";
		}
		else {
		 	$auth_token = $cnf->get('pptoken');
		 	$paypal = "www.paypal.com";
		}
			JLog::add('$paypal='.$paypal,JLog::DEBUG,'pdjx');
		
		$msg = "";
	
		$success = true;
		
		$req = 'cmd=_notify-synch';
		$tx_token = JRequest::getVar('tx', 0 );
			JLog::add('$tx_token = '.$tx_token,JLog::DEBUG,'pdjx');
		$req .= "&tx=".urlencode($tx_token)."&at=".urlencode($auth_token);
			JLog::add('$req = '.$req,JLog::DEBUG,'pdjx');
			
		// post back to PayPal system to validate
	
		$header = "POST /cgi-bin/webscr HTTP/1.1\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Host: " . $paypal . "\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n";
		$header .= "Connection: close\r\n\r\n"; 
	
		//$fp = fsockopen ($paypal, 80, $errno, $errstr, 30);
	
		$fp = fsockopen('ssl://'.$paypal, "443", $errno, $errstr, 30);
	
		if (!$fp || $errno) {
	 // HTTP ERROR -> try CURL
			JLog::add('HTTP ERROR -> try CURL',JLog::DEBUG,'pdjx');
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
			curl_setopt($ch,CURLOPT_URL,'https://'.$paypal.'/cgi-bin/webscr');
			curl_setopt($ch,CURLOPT_POST,1);
			curl_setopt($ch,CURLOPT_POSTFIELDS,$req);
			ob_start();
			curl_exec($ch);
			$res=ob_get_contents();
			curl_close($ch);
			ob_end_clean();
		} else {
			JLog::add('FSOCKETOPEN',JLog::DEBUG,'pdjx');
			fputs ($fp, $header . $req);
			// read the body data
			$res = '';
			$headerdone = false;
			$successPayment = false;
			$i=0;
			while (!feof($fp)) {
				$line = fgets ($fp, 1024);
				JLog::add('$line = '.$line,JLog::DEBUG,'pdjx');
				if (strcmp($line, "\r\n") == 0) {
					$headerdone = true;
					//JLog::add('test',JLog::DEBUG,'pdjx');

				}
				else if ($headerdone){
					// header has been read. now read the contents
					//JLog::add('test',JLog::DEBUG,'pdjx');
					
					//if($line = "SUCCESS") {
					//	$successPayment = true;
					//}
					
					$res .= $line;


				
				}

			}	
			fclose ($fp);
		}

		//JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
		// parse the data
		$lines = explode("\n", $res);
		//if($line = "SUCCESS"){
		//	$successPayment = true;
		//}
		//					
		$index = array_search('SUCCESS', $lines);
		//
		JLog::add('$ = ' . $index,JLog::DEBUG,'pdjx');
		//
		//if($successPayment = true) { 
		//	JLog::add('Najden SUCCESS v '. $index . '. vrstici',JLog::DEBUG,'pdjx');
        //
		//}
			
		$keyarray = array();
		if (strcmp ($lines[$index], "SUCCESS") == 0) {
			for ($i = $index+1; $i<count($lines);$i++){
			 	if ($lines[$i] != "") {
					JLog::add('$i = '.$i,JLog::DEBUG,'pdjx');
					list($key,$val) = array_pad(explode("=", $lines[$i]),2, null);
					$keyarray[urldecode($key)] = urldecode($val);
				}
			}
	
			$cheat = false;
			
			// fixed amount
			if (($item->donation == "0")&& (($keyarray['mc_gross'] != ($item->amount+$item->tax) || $keyarray['mc_currency'] != strtoupper($item->currency)))) {
			  $cheat = true;
			  		JLog::add("CHEATED:".$keyarray['mc_gross']." not ".($item->amount+$item->tax),JLog::DEBUG,'pdjx');
			 }
			//donation
			if (($item->donation == "1")&& (($keyarray['mc_gross'] < $item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency))) $cheat = true;
			// minimum (+tax)
			if (($item->donation == "2")&& (($keyarray['mc_gross'] < ($item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency)))) $cheat = true;
	
			if ($cheat)	{
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_NOT_CORRECT");
				return $success;
			}
		
			if($keyarray['payment_status'] == "Pending") {
				$dbo = JFactory::getDBO();
				$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
				$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
				$dbo->setQuery($query);
				$count = $dbo->loadResult();
				
				if (!$count) {
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_PAYMENT_PENDING");
					return $success;
								}
				else {
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				}		
			}
		
		
		
			// update the database
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			if (!$count) {
				$keyarray["dwnl"] = "0";
				$keyarray["testmode"] = intval($item->testmode);
				$keyarray["payment_date"] = strtotime($keyarray["payment_date"]);
		
				$my = JFactory::getUser();
		
				if (isset($my->id) && $my->id != 0) {
					$keyarray["userid"] = $my->id;
					$keyarray["actstatus"] = "A";
				}
				$keyarray["ip"] = $_SERVER['REMOTE_ADDR'];
				$keyarray["service"]="PDT";
				//jimport('joomla.application.component.model');
				//JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_paiddownloadsjx/models');
			    //
				//$user=JFactory::getUser();
				//$keyarray['userid']=$user->id;
				//$mdl_tx=JModelLegacy::getInstance('Transaction', 'PaiddownloadsjxModel');
				//$mdl_tx->store($keyarray);
				
				//send mail
				if ($cnf->get('send_conf_mail')) {
					JLog::add("Started sending mail...",JLog::DEBUG,'pdjx');
					$mailer = JFactory::getMailer();
					$config = JFactory::getConfig();
					$sender = array( 
						$config->get( 'mailfrom' ),
						$config->get( 'fromname' ) 
					);
					
					$mailer->setSender($sender);
					
					if ($item->testmode == 1) {
						$recipient = $cnf->get('test_confemail');
					}
					else {
						$recipient = $keyarray["payer_email"];
					}
					
					$mailer->addRecipient($recipient);
					
					$body = PdjxHelper::parseText($cnf->get('mail_text'), $item, $keyarray);
					$subject = PdjxHelper::parseText($cnf->get('mail_subject'), $item, $keyarray);
					$mailer->isHTML(true);
					$mailer->Encoding = 'base64';
					$mailer->setSubject($subject);
					$mailer->setBody($body);
			
					$send = $mailer->Send();
					if ( $send !== true ) {
						JLog::add("Error sending email: " . $send->__toString(),JLog::DEBUG,'pdjx');
						
					} else {
						JLog::add("Mail sent!",JLog::DEBUG,'pdjx');
					}
				}
			// check the payment_status is Completed
//				if (P2Dpro::onlyCompletedStatus($conf) == "1" && $keyarray["payment_status"] != "Completed") {
//					$success = "W";
//					$msg = JText::_("Payment was not yet completed.");
//				}
//				else {
//					P2Dpro::plgOnAfterRegistration($tx->id);
//					$success = "S";
//				}
			}
			else {
			
				$dbo = JFactory::getDBO();
				$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
				$query = "SELECT dwnl FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
				$dbo->setQuery($query);
				$downloads = $dbo->loadResult();
				if($downloads !== "0") {
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				}
				
			}
			
		}
		else if (strcmp ($lines[0], "FAIL") == 0) {
			$success = false;	
			$msg = JText::_("COM_PDJX_MSG_VERIFICATION_FAILED");
		}
		else {
			$success = false;	
			$msg = JText::_("COM_PDJX_MSG_DID_NOT_RETURN_VALUES");
		}
		return $success;
		
	}



//// IPN ///////	

	public static function validate(& $item, & $keyarray, & $msg){
		JLog::add('funcion validate(& $item)',JLog::DEBUG,'pdjx');	
		$cnf = JComponentHelper::getParams('com_paiddownloadsjx');

		if ($item->testmode == 1) {
		 	$auth_token = $cnf->get('test_pptoken');
		 	$paypal = "www.sandbox.paypal.com";
		}
		else {
		 	$auth_token = $cnf->get('pptoken');
		 	$paypal = "www.paypal.com";
		}
			JLog::add('$paypal='.$paypal,JLog::DEBUG,'pdjx');
		
		$msg = "";
	
		$success = true;
		
		$req = 'cmd=_notify-validate';
		$tx_token = JRequest::getVar('txn_id', 0 );
			JLog::add('$tx_token = '.$tx_token,JLog::DEBUG,'pdjx');
		$req .= "&tx=".urlencode($tx_token)."&at=".urlencode($auth_token);
			JLog::add('$req = '.$req,JLog::DEBUG,'pdjx');
			
		foreach ($_POST as $key => $value) {
			$value = urlencode(stripslashes($value));
    		$req .= "&$key=$value";
		}
		JLog::add('$req = '.$req,JLog::DEBUG,'pdjx');

		// post back to PayPal system to validate
	
		$header = "POST /cgi-bin/webscr HTTP/1.1\r\n";
		$header .= "Host: " . $paypal . "\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n";
		$header .= "Connection: close\r\n\r\n"; 

		//$fp = fsockopen ($paypal, 80, $errno, $errstr, 30);
	
		$fp = fsockopen('ssl://'.$paypal, 443, $errno, $errstr, 30);
	
		if (!$fp || $errno) {
	 // HTTP ERROR -> try CURL
			JLog::add('HTTP ERROR -> try CURL',JLog::DEBUG,'pdjx');
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,'https://'.$paypal.'/cgi-bin/webscr');
			curl_setopt($ch,CURLOPT_POST,1);
			curl_setopt($ch,CURLOPT_POSTFIELDS,$req);
			ob_start();
			curl_exec($ch);
			$res=ob_get_contents();
			curl_close($ch);
			ob_end_clean();
			JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
		
		} else {
			JLog::add('FSOCKETOPEN',JLog::DEBUG,'pdjx');
			fputs ($fp, $header . $req);
			// read the body data
			while (!feof($fp)) {
	/*			$line = fgets($fp, 1024);
				JLog::add('$line = '.$line,JLog::DEBUG,'pdjx');
				if (strcmp($line, "\r\n") == 0) {
					// read the header
					$headerdone = true;
					
				}
				else if ($headerdone)
				{
					// header has been read. now read the contents
					$res .= $line;
					JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
			} 	*/	

				$res1 = fgets($fp, 1024);
				$res = trim($res1);
				JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
				
				if (strcmp($res, "VERIFIED") == 0) {
					JLog::add('VERIFIED',JLog::DEBUG,'pdjx');
					
					$keyarray = array();
					
					foreach ($_POST as $key => $value) {
						$value = urlencode(stripslashes($value));
						$lines= "$key=$value";
						JLog::add('$lines = '.$lines,JLog::DEBUG,'pdjx');
			 			if ($lines != "") {
							list($keyA,$val) = explode("=", $lines);
							$keyarray[urldecode($keyA)] = urldecode($val);
							JLog::add($keyA.' = '.$keyarray[$keyA],JLog::DEBUG,'pdjx');
						}
					}
				}
				else if (strcmp($res, "INVALID") == 0){
					// header has been read. now read the contents
					JLog::add('INVALID',JLog::DEBUG,'pdjx');
					$success = false;
				}

			

			}
			fclose ($fp);
		}	

		
		if($keyarray['payment_status'] == "Completed") {
			$cheat = false;
			// fixed amount
			if (($item->donation == "0")&& (($keyarray['mc_gross'] != ($item->amount+$item->tax) || $keyarray['mc_currency'] != strtoupper($item->currency)))) {
			$cheat = true;
					JLog::add("CHEATED:".$keyarray['mc_gross']." not ".($item->amount+$item->tax),JLog::DEBUG,'pdjx');
			}
			//donation
			if (($item->donation == "1")&& (($keyarray['mc_gross'] < $item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency))) $cheat = true;
			// minimum (+tax)
			if (($item->donation == "2")&& (($keyarray['mc_gross'] < ($item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency)))) $cheat = true;
			
			if ($cheat)	{
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_NOT_CORRECT");
				return $success;
			}
			
			// update the database
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			if (!$count) {
				$keyarray["dwnl"] = "0";
				$keyarray["testmode"] = intval($item->testmode);
				$keyarray["payment_date"] = strtotime($keyarray["payment_date"]);
				$keyarray["userid"] = $keyarray["custom"];
				
				$my = JFactory::getUser();
			
				if (isset($my->id) && $my->id != 0) {
					$keyarray["actstatus"] = "A";
				}

				$keyarray["ip"] = $_SERVER['REMOTE_ADDR'];
				$keyarray["service"] = "IPN";
				
				
				jimport('joomla.application.component.model');
				JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_paiddownloadsjx/models');

				$mdl_tx=JModelLegacy::getInstance('Transaction', 'PaiddownloadsjxModel');
				$mdl_tx->store($keyarray);
			
				
				
				//send mail
				if ($cnf->get('send_conf_mail')) {
					JLog::add("Started sending mail...",JLog::DEBUG,'pdjx');
					$mailer = JFactory::getMailer();
					$config = JFactory::getConfig();
					$sender = array( 
						$config->get( 'mailfrom' ),
						$config->get( 'fromname' ) 
					);
					
					$mailer->setSender($sender);
					
					if ($item->testmode == 1) {
						$recipient = $cnf->get('test_confemail');
					}
					else {
						$recipient = $keyarray["payer_email"];
					}					
	
					$mailer->addRecipient($recipient);
					
					$body = PdjxHelper::parseText($cnf->get('mail_text'), $item, $keyarray);
					$subject = PdjxHelper::parseText($cnf->get('mail_subject'), $item, $keyarray);
					$mailer->isHTML(true);
					$mailer->Encoding = 'base64';
					$mailer->setSubject($subject);
					$mailer->setBody($body);
			
					$send = $mailer->Send();
					if ( $send !== true ) {
						JLog::add("Error sending email: " . $send->__toString(),JLog::DEBUG,'pdjx');
						
					} else {
						JLog::add("Mail sent!",JLog::DEBUG,'pdjx');
					}
				}
			
			
			}
			else {
				$dbo = JFactory::getDBO();
				$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
				$query = "SELECT dwnl FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
				$dbo->setQuery($query);
				$downloads = $dbo->loadResult();
				if($downloads !== "0") {
					JLog::add($downloads,JLog::DEBUG,'pdjx');
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				}
				//$success = false;
				JLog::add("Transaction already processed!",JLog::DEBUG,'pdjx');
			}

		}
		else if($keyarray['payment_status'] == "Pending") {
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			
			if (!$count) {
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_PENDING");
			
			}
			else {
			
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				
			}
		
		}
		// parse the data
		/*
		$lines = explode("\n", $res);
		JLog::add('$lines = '.$lines,JLog::DEBUG,'pdjx');
		$keyarray = array();
		if (strcmp ($lines[0], "SUCCESS") == 0) {
			for ($i=1; $i<count($lines);$i++){
			 	if ($lines[$i] != "") {
					list($key,$val) = explode("=", $lines[$i]);
					$keyarray[urldecode($key)] = urldecode($val);
					JLog::add('$keyarray = '.$keyarray,JLog::DEBUG,'pdjx');
				}
			}
	
			$cheat = false;
			
			// fixed amount
			if (($item->donation == "0")&& (($keyarray['mc_gross'] != ($item->amount+$item->tax) || $keyarray['mc_currency'] != strtoupper($item->currency)))) {
			  $cheat = true;
			  		JLog::add("CHEATED:".$keyarray['mc_gross']." not ".($item->amount+$item->tax),JLog::DEBUG,'pdjx');
			 }
			//donation
			if (($item->donation == "1")&& (($keyarray['mc_gross'] < $item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency))) $cheat = true;
			// minimum (+tax)
			if (($item->donation == "2")&& (($keyarray['mc_gross'] < ($item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency)))) $cheat = true;
	
			if ($cheat)	{
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_NOT_CORRECT");
				return $success;
			}
		
			// update the database
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			if (!$count) {
				$keyarray["dwnl"] = "0";
				$keyarray["testmode"] = intval($item->testmode);
				$keyarray["payment_date"] = strtotime($keyarray["payment_date"]);
		
				$my = JFactory::getUser();
		
				if (isset($my->id) && $my->id != 0) {
					$keyarray["userid"] = $my->id;
					$keyarray["actstatus"] = "A";
				}
				$keyarray["ip"] = $_SERVER['REMOTE_ADDR'];
		
			// check the payment_status is Completed
//				if (P2Dpro::onlyCompletedStatus($conf) == "1" && $keyarray["payment_status"] != "Completed") {
//					$success = "W";
//					$msg = JText::_("Payment was not yet completed.");
//				}
//				else {
//					P2Dpro::plgOnAfterRegistration($tx->id);
//					$success = "S";
//				}
			}
			else {
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
			}
		}
		else if (strcmp ($lines[0], "FAIL") == 0) {
			$success = false;	
			
			$msg = JText::_("COM_PDJX_MSG_VERIFICATION_FAILED");
		}
		else {
			$success = false;	
			$msg = JText::_("COM_PDJX_MSG_DID_NOT_RETURN_VALUES");
		}
		return $success;
		*/
		return $success;
	}
	
public static function parseText($text, $item, $txdata = false) {
		// Transaction specific variables
		if ($txdata) {
			$text = str_replace("[FIRST_NAME]", $txdata['first_name'], $text);
			$text = str_replace("[LAST_NAME]", $txdata['last_name'], $text);
			$text = str_replace("[ITEM_NUMBER]", $txdata['item_number'], $text);
			$text = str_replace("[TXN_ID]", $txdata['txn_id'], $text);
		}
		// item specific
		$text = str_replace("[ITEM]", $item->itemname, $text);

		$text = str_replace("[BASE_URL]", JURI::base(), $text);
		
		
			//donation vs. purchase
		if ($item->donation != "0") {
			$text = preg_replace("/(\[DONATION\](.*?)\[\/DONATION\])/is",'$2', $text);
			$text = preg_replace("/(\[PURCHASE\](.*?)\[\/PURCHASE\])/is",'', $text);

		}		
		else {
			$text = preg_replace("/(\[DONATION\](.*?)\[\/DONATION\])/is",'', $text);
			$text = preg_replace("/(\[PURCHASE\](.*?)\[\/PURCHASE\])/is",'$2', $text);
		}
		
		return $text;
		
	}

}

