<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

defined('_JEXEC') or die;

abstract class PdjxHelper
{
	function readfile_chunked($filename,$retbytes=true)
    {
   		$chunksize = 1*(1024*1024); // how many bytes per chunk
   		$buffer = '';
   		$cnt =0;
   		$handle = fopen($filename, 'rb');
   		if ($handle === false) {
       		return false;
   		}
   		while (!feof($handle)) {
       		$buffer = fread($handle, $chunksize);
       		echo $buffer;
			@ob_flush();
			flush();
       		if ($retbytes) {
           		$cnt += strlen($buffer);
       		}
   		}
       $status = fclose($handle);
   	   if ($retbytes && $status) {
       		return $cnt; // return num. bytes delivered like readfile() does.
   		}
   		return $status;
	}
	
	public static function setCtype ($file_extension) {
		//This will set the Content-Type to the appropriate setting for the file
		switch( $file_extension ) {
			 case "pdf": $ctype="application/pdf"; break;
		     case "exe": $ctype="application/octet-stream"; break;
		     case "zip": $ctype="application/zip"; break;
		     case "doc": $ctype="application/msword"; break;
		     case "xls": $ctype="application/vnd.ms-excel"; break;
		     case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
		     case "gif": $ctype="image/gif"; break;
		     case "png": $ctype="image/png"; break;
		     case "jpeg":
		     case "jpg": $ctype="image/jpg"; break;
		     case "mp3": $ctype="audio/mpeg"; break;
		     case "wav": $ctype="audio/x-wav"; break;
		     case "mpeg":
		     case "mpg":
		     case "mpe": $ctype="video/mpeg"; break;
		     case "mov": $ctype="video/quicktime"; break;
		     case "avi": $ctype="video/x-msvideo"; break;
		     //The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
		     case "php":
		     case "htm":
		     case "html": if ($downpath) die("<b>Cannot be used for ". $file_extension ." files!</b>");
		     default: $ctype="application/force-download";
		}
		return $ctype;

	}

	
////// PDT //////

	public static function validate_PDT(& $item, & $keyarray, & $msg){
				JLog::add('funcion validate(& $item)',JLog::DEBUG,'pdjx');	
	
		$cnf = JComponentHelper::getParams('com_paiddownloadsjx');
		
		if ($item->testmode == 1) {
		 	$auth_token = $cnf->get('test_pptoken');
		 	$paypal = "www.sandbox.paypal.com";
		}
		else {
		 	$auth_token = $cnf->get('pptoken');
		 	$paypal = "www.paypal.com";
		}
			JLog::add('$paypal='.$paypal,JLog::DEBUG,'pdjx');
		
		$msg = "";
	
		$success = true;
		
		$req = 'cmd=_notify-synch';
		$tx_token = JRequest::getVar('tx', 0 );
			JLog::add('$tx_token = '.$tx_token,JLog::DEBUG,'pdjx');
		$req .= "&tx=".urlencode($tx_token)."&at=".urlencode($auth_token);
			JLog::add('$req = '.$req,JLog::DEBUG,'pdjx');
			
		// post back to PayPal system to validate
	
		$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Host: " . $paypal . "\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
	
		//$fp = fsockopen ($paypal, 80, $errno, $errstr, 30);
	
		$fp = fsockopen('ssl://'.$paypal, "443", $errno, $errstr, 30);
	
		if (!$fp || $errno) {
	 // HTTP ERROR -> try CURL
			JLog::add('HTTP ERROR -> try CURL',JLog::DEBUG,'pdjx');
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
			curl_setopt($ch,CURLOPT_URL,'https://'.$paypal.'/cgi-bin/webscr');
			curl_setopt($ch,CURLOPT_POST,1);
			curl_setopt($ch,CURLOPT_POSTFIELDS,$req);
			ob_start();
			curl_exec($ch);
			$res=ob_get_contents();
			curl_close($ch);
			ob_end_clean();
		} else {
			JLog::add('FSOCKETOPEN',JLog::DEBUG,'pdjx');
			fputs ($fp, $header . $req);
			// read the body data
			$res = '';
			$headerdone = false;
			$i=0;
			while (!feof($fp)) {
				$line = fgets ($fp, 1024);
				JLog::add('$line = '.$line,JLog::DEBUG,'pdjx');
				if (strcmp($line, "\r\n") == 0) {
					$headerdone = true;
				}
				else if ($headerdone){
					// header has been read. now read the contents
					$res .= $line;
				}
			}	
			fclose ($fp);
		}
		// parse the data
		$lines = explode("\n", $res);
				JLog::add('$lines = '.$lines[0],JLog::DEBUG,'pdjx');
		$keyarray = array();
		if (strcmp ($lines[0], "SUCCESS") == 0) {
			for ($i=1; $i<count($lines);$i++){
			 	if ($lines[$i] != "") {
					list($key,$val) = explode("=", $lines[$i]);
					$keyarray[urldecode($key)] = urldecode($val);
				}
			}
	
			$cheat = false;
			
			// fixed amount
			if (($item->donation == "0")&& (($keyarray['mc_gross'] != ($item->amount+$item->tax) || $keyarray['mc_currency'] != strtoupper($item->currency)))) {
			  $cheat = true;
			  		JLog::add("CHEATED:".$keyarray['mc_gross']." not ".($item->amount+$item->tax),JLog::DEBUG,'pdjx');
			 }
			//donation
			if (($item->donation == "1")&& (($keyarray['mc_gross'] < $item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency))) $cheat = true;
			// minimum (+tax)
			if (($item->donation == "2")&& (($keyarray['mc_gross'] < ($item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency)))) $cheat = true;
	
			if ($cheat)	{
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_NOT_CORRECT");
				return $success;
			}
		
			if($keyarray['payment_status'] == "Pending") {
				$dbo = JFactory::getDBO();
				$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
				$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
				$dbo->setQuery($query);
				$count = $dbo->loadResult();
				
				if (!$count) {
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_PAYMENT_PENDING");
					return $success;
								}
				else {
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				}		
			}
		
		
		
			// update the database
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			if (!$count) {
				$keyarray["dwnl"] = "0";
				$keyarray["testmode"] = intval($item->testmode);
				$keyarray["payment_date"] = strtotime($keyarray["payment_date"]);
		
				$my = JFactory::getUser();
		
				if (isset($my->id) && $my->id != 0) {
					$keyarray["userid"] = $my->id;
					$keyarray["actstatus"] = "A";
				}
				$keyarray["ip"] = $_SERVER['REMOTE_ADDR'];
				
				//jimport('joomla.application.component.model');
				//JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_paiddownloadsjx/models');
			    //
				//$user=JFactory::getUser();
				//$keyarray['userid']=$user->id;
				//$mdl_tx=JModelLegacy::getInstance('Transaction', 'PaiddownloadsjxModel');
				//$mdl_tx->store($keyarray);
				
				//send mail
				if ($cnf->get('send_conf_mail')) {
					JLog::add("Started sending mail...",JLog::DEBUG,'pdjx');
					$mailer = JFactory::getMailer();
					$config = JFactory::getConfig();
					$sender = array( 
						$config->get( 'mailfrom' ),
						$config->get( 'fromname' ) 
					);
					
					$mailer->setSender($sender);
					
					if ($item->testmode == 1) {
						$recipient = $cnf->get('test_confemail');
					}
					else {
						$recipient = $keyarray["payer_email"];
					}
					
					$mailer->addRecipient($recipient);
					
					$body = PdjxHelper::parseText($cnf->get('mail_text'), $item, $keyarray);
					$subject = PdjxHelper::parseText($cnf->get('mail_subject'), $item, $keyarray);
					$mailer->isHTML(true);
					$mailer->Encoding = 'base64';
					$mailer->setSubject($subject);
					$mailer->setBody($body);
			
					$send = $mailer->Send();
					if ( $send !== true ) {
						JLog::add("Error sending email: " . $send->__toString(),JLog::DEBUG,'pdjx');
						
					} else {
						JLog::add("Mail sent!",JLog::DEBUG,'pdjx');
					}
				}
			// check the payment_status is Completed
//				if (P2Dpro::onlyCompletedStatus($conf) == "1" && $keyarray["payment_status"] != "Completed") {
//					$success = "W";
//					$msg = JText::_("Payment was not yet completed.");
//				}
//				else {
//					P2Dpro::plgOnAfterRegistration($tx->id);
//					$success = "S";
//				}
			}
			else {
				$dbo = JFactory::getDBO();
				$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
				$query = "SELECT dwnl FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
				$dbo->setQuery($query);
				$downloads = $dbo->loadResult();
				if($downloads !== "0") {
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				}
			}
			
		}
		else if (strcmp ($lines[0], "FAIL") == 0) {
			$success = false;	
			$msg = JText::_("COM_PDJX_MSG_VERIFICATION_FAILED");
		}
		else {
			$success = false;	
			$msg = JText::_("COM_PDJX_MSG_DID_NOT_RETURN_VALUES");
		}
		return $success;
		
	}



//// IPN ///////	

	public static function validate(& $item, & $keyarray, & $msg){
		JLog::add('funcion validate(& $item)',JLog::DEBUG,'pdjx');	
		$cnf = JComponentHelper::getParams('com_paiddownloadsjx');
		
		if ($item->testmode == 1) {
		 	$auth_token = $cnf->get('test_pptoken');
		 	$paypal = "www.sandbox.paypal.com";
		}
		else {
		 	$auth_token = $cnf->get('pptoken');
		 	$paypal = "www.paypal.com";
		}
			JLog::add('$paypal='.$paypal,JLog::DEBUG,'pdjx');
		
		$msg = "";
	
		$success = true;
		
		$req = 'cmd=_notify-validate';
		$tx_token = JRequest::getVar('txn_id', 0 );
			JLog::add('$tx_token = '.$tx_token,JLog::DEBUG,'pdjx');
		$req .= "&tx=".urlencode($tx_token)."&at=".urlencode($auth_token);
			JLog::add('$req = '.$req,JLog::DEBUG,'pdjx');
			
		foreach ($_POST as $key => $value) {
			$value = urlencode(stripslashes($value));
    		$req .= "&$key=$value";
		}
		JLog::add('$req = '.$req,JLog::DEBUG,'pdjx');

		// post back to PayPal system to validate
	
		$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Host: " . $paypal . "\r\n";
		//$header .= "Connection: close\r\n"; 
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";

		//$fp = fsockopen ($paypal, 80, $errno, $errstr, 30);
	
		$fp = fsockopen('ssl://'.$paypal, 443, $errno, $errstr, 30);
	
		if (!$fp || $errno) {
	 // HTTP ERROR -> try CURL
			JLog::add('HTTP ERROR -> try CURL',JLog::DEBUG,'pdjx');
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,'https://'.$paypal.'/cgi-bin/webscr');
			curl_setopt($ch,CURLOPT_POST,1);
			curl_setopt($ch,CURLOPT_POSTFIELDS,$req);
			ob_start();
			curl_exec($ch);
			$res=ob_get_contents();
			curl_close($ch);
			ob_end_clean();
			JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
		
		} else {
			JLog::add('FSOCKETOPEN',JLog::DEBUG,'pdjx');
			fputs ($fp, $header . $req);
			// read the body data
			while (!feof($fp)) {
	/*			$line = fgets($fp, 1024);
				JLog::add('$line = '.$line,JLog::DEBUG,'pdjx');
				if (strcmp($line, "\r\n") == 0) {
					// read the header
					$headerdone = true;
					
				}
				else if ($headerdone)
				{
					// header has been read. now read the contents
					$res .= $line;
					JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
			} 	*/	

				$res = fgets($fp, 1024);
				JLog::add('$res = '.$res,JLog::DEBUG,'pdjx');
				
				if (strcmp($res, "VERIFIED") == 0) {
					JLog::add('VERIFIED',JLog::DEBUG,'pdjx');
					
					$keyarray = array();
					
					foreach ($_POST as $key => $value) {
						$value = urlencode(stripslashes($value));
						$lines= "$key=$value";
						JLog::add('$lines = '.$lines,JLog::DEBUG,'pdjx');
			 			if ($lines != "") {
							list($keyA,$val) = explode("=", $lines);
							$keyarray[urldecode($keyA)] = urldecode($val);
							JLog::add($keyA.' = '.$keyarray[$keyA],JLog::DEBUG,'pdjx');
						}
					}
				}
				else if (strcmp($res, "INVALID") == 0){
					// header has been read. now read the contents
					JLog::add('INVALID',JLog::DEBUG,'pdjx');
					$success = false;
				}

			
			
			}
			fclose ($fp);
		}	

		
		if($keyarray['payment_status'] == "Completed") {
			$cheat = false;
			// fixed amount
			if (($item->donation == "0")&& (($keyarray['mc_gross'] != ($item->amount+$item->tax) || $keyarray['mc_currency'] != strtoupper($item->currency)))) {
			$cheat = true;
					JLog::add("CHEATED:".$keyarray['mc_gross']." not ".($item->amount+$item->tax),JLog::DEBUG,'pdjx');
			}
			//donation
			if (($item->donation == "1")&& (($keyarray['mc_gross'] < $item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency))) $cheat = true;
			// minimum (+tax)
			if (($item->donation == "2")&& (($keyarray['mc_gross'] < ($item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency)))) $cheat = true;
			
			if ($cheat)	{
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_NOT_CORRECT");
				return $success;
			}
			
			// update the database
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			if (!$count) {
				$keyarray["dwnl"] = "0";
				$keyarray["testmode"] = intval($item->testmode);
				$keyarray["payment_date"] = strtotime($keyarray["payment_date"]);
				$my = JFactory::getUser();
			
				if (isset($my->id) && $my->id != 0) {
					$keyarray["userid"] = $my->id;
					$keyarray["actstatus"] = "A";
				}

				$keyarray["ip"] = $_SERVER['REMOTE_ADDR'];

				jimport('joomla.application.component.model');
				JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_paiddownloadsjx/models');

				$user=JFactory::getUser();
				$keyarray['userid']=$user->id;
				$mdl_tx=JModelLegacy::getInstance('Transaction', 'PaiddownloadsjxModel');
				$mdl_tx->store($keyarray);
			
				
				
				//send mail
				if ($cnf->get('send_conf_mail')) {
					JLog::add("Started sending mail...",JLog::DEBUG,'pdjx');
					$mailer = JFactory::getMailer();
					$config = JFactory::getConfig();
					$sender = array( 
						$config->get( 'mailfrom' ),
						$config->get( 'fromname' ) 
					);
					
					$mailer->setSender($sender);
					
					if ($item->testmode == 1) {
						$recipient = $cnf->get('test_confemail');
					}
					else {
						$recipient = $keyarray["payer_email"];
					}					
	
					$mailer->addRecipient($recipient);
					
					$body = PdjxHelper::parseText($cnf->get('mail_text'), $item, $keyarray);
					$subject = PdjxHelper::parseText($cnf->get('mail_subject'), $item, $keyarray);
					$mailer->isHTML(true);
					$mailer->Encoding = 'base64';
					$mailer->setSubject($subject);
					$mailer->setBody($body);
			
					$send = $mailer->Send();
					if ( $send !== true ) {
						JLog::add("Error sending email: " . $send->__toString(),JLog::DEBUG,'pdjx');
						
					} else {
						JLog::add("Mail sent!",JLog::DEBUG,'pdjx');
					}
				}
			
			
			}
			else {
				$dbo = JFactory::getDBO();
				$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
				$query = "SELECT dwnl FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
				$dbo->setQuery($query);
				$downloads = $dbo->loadResult();
				if($downloads !== "0") {
					JLog::add($downloads,JLog::DEBUG,'pdjx');
					$success = false;
					$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				}
				//$success = false;
				JLog::add("Transaction already processed!",JLog::DEBUG,'pdjx');
			}

		}
		else if($keyarray['payment_status'] == "Pending") {
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			
			if (!$count) {
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_PENDING");
			
			}
			else {
			
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
				
			}
		
		}
		// parse the data
		/*
		$lines = explode("\n", $res);
		JLog::add('$lines = '.$lines,JLog::DEBUG,'pdjx');
		$keyarray = array();
		if (strcmp ($lines[0], "SUCCESS") == 0) {
			for ($i=1; $i<count($lines);$i++){
			 	if ($lines[$i] != "") {
					list($key,$val) = explode("=", $lines[$i]);
					$keyarray[urldecode($key)] = urldecode($val);
					JLog::add('$keyarray = '.$keyarray,JLog::DEBUG,'pdjx');
				}
			}
	
			$cheat = false;
			
			// fixed amount
			if (($item->donation == "0")&& (($keyarray['mc_gross'] != ($item->amount+$item->tax) || $keyarray['mc_currency'] != strtoupper($item->currency)))) {
			  $cheat = true;
			  		JLog::add("CHEATED:".$keyarray['mc_gross']." not ".($item->amount+$item->tax),JLog::DEBUG,'pdjx');
			 }
			//donation
			if (($item->donation == "1")&& (($keyarray['mc_gross'] < $item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency))) $cheat = true;
			// minimum (+tax)
			if (($item->donation == "2")&& (($keyarray['mc_gross'] < ($item->amount) || $keyarray['mc_currency'] != strtoupper($item->currency)))) $cheat = true;
	
			if ($cheat)	{
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_PAYMENT_NOT_CORRECT");
				return $success;
			}
		
			// update the database
			$dbo = JFactory::getDBO();
			$tx_token_quoted=$dbo->quote($tx_token); //qoute and escape $tx_token
			$query = "SELECT COUNT(*) FROM #__pdjx_tx WHERE txn_id = $tx_token_quoted";
			$dbo->setQuery($query);
			$count = $dbo->loadResult();
			if (!$count) {
				$keyarray["dwnl"] = "0";
				$keyarray["testmode"] = intval($item->testmode);
				$keyarray["payment_date"] = strtotime($keyarray["payment_date"]);
		
				$my = JFactory::getUser();
		
				if (isset($my->id) && $my->id != 0) {
					$keyarray["userid"] = $my->id;
					$keyarray["actstatus"] = "A";
				}
				$keyarray["ip"] = $_SERVER['REMOTE_ADDR'];
		
			// check the payment_status is Completed
//				if (P2Dpro::onlyCompletedStatus($conf) == "1" && $keyarray["payment_status"] != "Completed") {
//					$success = "W";
//					$msg = JText::_("Payment was not yet completed.");
//				}
//				else {
//					P2Dpro::plgOnAfterRegistration($tx->id);
//					$success = "S";
//				}
			}
			else {
				$success = false;
				$msg = JText::_("COM_PDJX_MSG_ALREADY_PROCESSED"); 
			}
		}
		else if (strcmp ($lines[0], "FAIL") == 0) {
			$success = false;	
			
			$msg = JText::_("COM_PDJX_MSG_VERIFICATION_FAILED");
		}
		else {
			$success = false;	
			$msg = JText::_("COM_PDJX_MSG_DID_NOT_RETURN_VALUES");
		}
		return $success;
		*/
		return $success;
	}
	
public static function parseText($text, $item, $txdata = false) {
		// Transaction specific variables
		if ($txdata) {
			$text = str_replace("[FIRST_NAME]", $txdata['first_name'], $text);
			$text = str_replace("[LAST_NAME]", $txdata['last_name'], $text);
		}
		// item specific
		$text = str_replace("[ITEM]", $item->itemname, $text);
		
			//donation vs. purchase
		if ($item->donation != "0") {
			$text = preg_replace("/(\[DONATION\](.*?)\[\/DONATION\])/is",'$2', $text);
			$text = preg_replace("/(\[PURCHASE\](.*?)\[\/PURCHASE\])/is",'', $text);

		}		
		else {
			$text = preg_replace("/(\[DONATION\](.*?)\[\/DONATION\])/is",'', $text);
			$text = preg_replace("/(\[PURCHASE\](.*?)\[\/PURCHASE\])/is",'$2', $text);
		}
		
		return $text;
		
	}

}

