<?php

/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

/**
 * Methods supporting a list of Pdjx records.
 */
class PaiddownloadsjxModelFiles extends JModelList
{
    /**
     * Constructor.
     *
     * @param array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
    public function __construct($config = array()) {
        parent::__construct($config);
    }

    /**
     * Method to auto-populate the model state.
     *
     * Note. Calling getState in this method will result in recursion.
     *
     * @since    1.6
     */
    protected function populateState($ordering = null, $direction = null) {

        // Initialise variables.
        $app = JFactory::getApplication();

        // List state information
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'));
        $this->setState('list.limit', $limit);

        $limitstart = JFactory::getApplication()->input->getInt('limitstart', 0);
        $this->setState('list.start', $limitstart);


        if (empty($ordering)) {
            $ordering = 'a.ordering';
        }

        // List state information.
        parent::populateState($ordering, $direction);
    }

    public function getLastVersion($fileid) {
        $dbo = $this->getDbo();
        $query = "SELECT * FROM #__pdjx_versions WHERE fileid = $fileid AND state = 1 ORDER BY version DESC LIMIT 1";
        $dbo->setQuery($query);
        return $dbo->loadObject();
    }

    public function getVersion($versionid) {
        $dbo = $this->getDbo();
        $query = "SELECT * FROM #__pdjx_versions WHERE id = $versionid LIMIT 1";
        $dbo->setQuery($query);
        return $dbo->loadObject();
    }

    /**
     * Build an SQL query to load the list data.
     *
     * @return    JDatabaseQuery
     * @since    1.6
     */
    protected function getListQuery() {
        // Create a new query object.
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $user = JFactory::getUser();

        // Select the required fields from the table.
        $query->select(
            $this->getState(
                'list.select', 'a.*'
            )
        );
        $query->select('tx.id as tx_id');
        $query->from('`#__pdjx_files` AS a');


        // Join over the users for the checked out user.

        $query->join('LEFT', "(SELECT * FROM `#__pdjx_tx` as tx 
    						WHERE (payer_email='$user->email' && payer_email != '') 
    							OR (userid = $user->id && userid <> 0) ) 
    						AS tx ON a.id=tx.item_number");

        $query->where('a.state = 1');

        // Filter by search in title
        $search = $this->getState('filter.search');
        if (!empty($search)) {
            if (stripos($search, 'id:') === 0) {
                $query->where('a.id = ' . (int)substr($search, 3));
            } else {
                $search = $db->Quote('%' . $db->escape($search, true) . '%');

            }
        }

        // Add the list ordering clause.
        $orderCol = $this->state->get('list.ordering', 'a.ordering');
        $orderDirn = $this->state->get('list.direction', 'asc');
        $query->order($db->escape($orderCol . ' ' . $orderDirn));


        return $query;
    }
}
