<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modelform');
jimport('joomla.event.dispatcher');

/**
 * Pdjx model.
 */
class PaiddownloadsjxModelTransaction extends JModelLegacy
{
    
    var $_item = null;
    var $_ID = null;
   
	public function getTable($type = 'Transaction', $prefix = 'PaiddownloadsjxTable', $config = array())
	{   
        $this->addTablePath(JPATH_COMPONENT_ADMINISTRATOR.'/tables');
        return JTable::getInstance($type, $prefix, $config);
	}     

	public function store($data)
	{
	 	$row = $this->getTable();
	 	
       if (!$row->bind($data))
       {
          $this->setError($this->_db->getErrorMsg());     
          JLog::add('Bind failed:'.$this->_db->getErrorMsg(),JLog::DEBUG,'pdjx');	     
          return false;
       }
        if ($row->store() === true) {
        		JLog::add('Transaction saved',JLog::DEBUG,'pdjx');
            return true;
        } else {
        	JLog::add($this->_db->getErrorMsg(),JLog::DEBUG,'pdjx');
            return false;
        }
	}
	
	public function getDataFromTxnID($txn){
		$dbo=$this->getDbo();
		$txn=$dbo->quote($txn);
		$query="SELECT * FROM #__pdjx_tx WHERE txn_id = $txn";
		$dbo->setQuery($query);
		$this->_item = $dbo->loadObject();
		return $this->_item;
	}
	
	public function getDataFromID($id){
		$dbo=$this->getDbo();
		$id=$dbo->quote($id);
		$query="SELECT * FROM #__pdjx_tx WHERE id = $id";
		$dbo->setQuery($query);
		$this->_item = $dbo->loadObject();
		return $this->_item;
	}
	
	/**
	 * 
	 * Enter description here ...
	 * @param $user_object 
	 * @param $productid
	 */
	public function getDataFromUserAndProduct(&$user_object, $productid){
		$dbo=$this->getDbo();
		$email=$dbo->quote($user_object->email);
		$productid = $dbo->quote($productid);
		$query="SELECT * FROM #__pdjx_tx 
				WHERE (userid = $user_object->id OR payer_email = $email) 
					AND item_number = $productid 
				ORDER BY payment_date DESC ";
		$dbo->setQuery($query);
		$this->_item = $dbo->loadObject();
		return $this->_item;
	}
	
	public function incrDwnlCount(){
		$dbo=$this->getDbo();
		$id=$dbo->quote($this->_item->id);
		$query="UPDATE #__pdjx_tx SET dwnl=dwnl+1 WHERE id = $id";
		$dbo->setQuery($query);
		$dbo->execute();
	}
	
//	public function &getData($id = null)
//	{
//		if ($this->_item === null){
//			$this->_item = false;
//
//			// Get a level row instance.
//			$table = $this->getTable();
//			
//			// Attempt to load the row.
//			if ($table->load($id)){
//				$properties = $table->getProperties(1);
//				$this->_item = JArrayHelper::toObject($properties, 'JObject');
//				
//			} elseif ($error = $table->getError()) {
//				$this->setError($error);
//			}
//		}
//		return $this->_item;
//	} 
//	 
	
//     function delete($data)
//    {
//        $id = (!empty($data['id'])) ? $data['id'] : (int)$this->getState('file.id');
//        if(JFactory::getUser()->authorise('core.delete', 'com_paiddownloadsjx') !== true){
//            JError::raiseError(403, JText::_('JERROR_ALERTNOAUTHOR'));
//            return false;
//        }
//        $table = $this->getTable();
//        if ($table->delete($data['id']) === true) {
//            return $id;
//        } else {
//            return false;
//        }
//        
//        return true;
//    }
    
}