<?php

/**
 * Description of GraphConf
 *
 * Configuration variables for GraphView
 * @author dauid
 */
class GraphConf {
    var $refreshTime;
    var $size;
    var $graphType;
    var $showPoints;
    var $showLegend;
    var $showLines;
    var $fillGraph;
    var $limit_radio;
    var $limit;
    var $offset_radio;
    var $offset;
    var $mode;
    var $xaxis;
    var $step;

    function  __construct($data) {
        $tmp = explode("|", $data);

        $this->refreshTime  = $tmp[0];
        $this->graphType    = $tmp[2];
        $this->showPoints   = $tmp[3];
        $this->showLegend   = $tmp[4];
        $this->showLines    = $tmp[5];
        $this->fillGraph    = $tmp[6];
        $this->limit_radio  = $tmp[7];
        $this->limit        = $tmp[8];
        $this->offset_radio = $tmp[9];
        $this->offset       = $tmp[10];
        $this->mode         = $tmp[11];
        $this->xaxis        = $tmp[12];
        $this->step         = $tmp[13];

        $tmp = explode(",", $tmp[1]);
        $this->size[0]         = $tmp[0];
        $this->size[1]         = $tmp[1];
    }

    function generateTick($table, $db, $id, $totalColumns, $columnCaptions, $stringType, &$isDecimal, &$decimals, $off) {
        $i=0;
        switch($this->graphType) {
            case "barv":
            case "line": {
                    //$ticks="[";

                    if($this->xaxis!="none") {     //if we set x-axis values
                        if($stringType) {//datatype is string
                            $db->setQuery("SELECT COUNT(*) FROM ".$table);
                            $db->query();
                            $maxtick=$db->loadResult()-1;
                            $tick=0;
                            if($this->offset_radio)
                                $tick+=$this->offset;
                            if($this->limit_radio)
                                if($this->mode!=2) $maxtick=$tick+$this->limit;
                            $db->setQuery("SELECT ".$this->xaxis." FROM ".$table);
                            $result=$db->loadResultArray();
                            while($tick<$maxtick) {
                                //$ticks.=$tick."-offset".$id.",\"".$result[$tick]."\"|";
                                //$ticks.="[".$tick."-offset".$id.",\"".$result[$tick]."\"],";
                                $ticks.=$tick-$off.",".$result[$tick].";";
                                $tick++;
                            }
                            $ticks.=$tick-$off.",".$result[$tick];
                            //$ticks.="[".$tick."-offset".$id.",\"".$result[$tick]."\"]]";

                        } else { //start if integer
                            //get min value of x-axis
                            if($this->offset_radio && $this->mode!=2)
                                $db->setQuery("SELECT MIN(".$this->xaxis.") FROM (SELECT ".$this->xaxis." FROM ".$table." ORDER BY ".$this->xaxis."
                         LIMIT ".$this->offset.",".($this->limit_radio?$this->limit:$totalRows-$this->offset).") as T1");
                            elseif($this->mode==2)
                                $db->setQuery("SELECT MIN(".$this->xaxis.") FROM (SELECT ".$this->xaxis." FROM ".$table." ORDER BY ".$this->xaxis."
                         LIMIT ".$this->offset.",".($this->limit_radio?$this->limit:$totalRows-$this->offset).") as T1");
                            else $db->setQuery("SELECT MIN(".$this->xaxis.") FROM ".$table);
                            $db->query();
                            $tick=$db->loadResult();

                            //if($this->mode==2) $tick=($this->offset==0?$tick:$this->offset);

                            //get max value of x-axis
                            if($this->limit_radio && $this->mode!=2)
                                $db->setQuery("SELECT MAX(".$this->xaxis.") FROM (SELECT ".$this->xaxis." FROM ".$table." ORDER BY ".$this->xaxis."
                         LIMIT ".$this->offset.",".($this->limit_radio?$this->limit:$totalRows-$this->offset).") as T1");
                            else $db->setQuery("SELECT MAX(".$this->xaxis.") FROM ".$table);
                            $db->query();
                            $maxtick=$db->loadResult();

                            if(strlen(strstr($this->step, "."))<0) $decimals="null";
                            else $decimals=strlen(strstr($this->step, "."))-1;
                            if($this->step<1) $isDecimal=true;

                            while($tick<$maxtick) {
                                //$ticks[$i][0]=$tick;
                                $ticks.=$tick.",".(!$isDecimal?(int)$tick:$tick).";";
                                $tick+=$this->step;
                            }
                            $ticks.=$tick.",".$tick;
                        }//end if integer
                    }else {       //else will flot automaticaly generate x-axis depending on number of data
                        $ticks="";
                    }
                } break
                ;
            case "barh": {
                    $ticks="[";
                    $step=1;

                    while($tick<$totalColumns) {
                        $ticks.="[".($tick-1).", \"".$columnCaptions[$tick-1]."\"], ";
                        $tick+=$step;
                    }

                    $ticks.="[".($totalColumns-1).", \"".$columnCaptions[$totalColumns-1]."\"]]";
                } break
                ;
        }
        return $ticks;
    }
}
?>
