<?php
/**
 * @version     2.5.1
 * @package     com_grid
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */
//allow acces only trough joomla
defined( '_JEXEC' ) or die( 'Restricted access' );
class GraphView extends GridBuilder {

	function beforeQuery() {
		//for frontent rows per page selection
		$this->queryStart = $this->page*$this->rpp; //for frontent rows per page selection
		$this->queryLimit = $this->rpp;
	}

	function makeObject() {
		require_once JPATH_ROOT."/components"."/com_grid".'/GraphConf.php';
		$graphConfig = new GraphConf($this->_config->graphConfig);
		if(!$graphConfig->limit_radio) $graphConfig->limit=0;
		if(!$graphConfig->offset_radio) $graphConfig->offset=0;
		return $graphConfig;
	}

	function includeJS($document, $browser) {
		$app = JFactory::getApplication();
		if($browser->getBrowser()=="msie" && (int)($browser->getVersion())<=8)
				$document->addScript("components/com_grid/js/flot/excanvas.min.js");
		
		$document->addScript("components/com_grid/js/flot/jquery.js");
	
 		$document->addScript("components/com_grid/js/flot/jquery.flot.js");

		$document->addScript("components/com_grid/js/graph.js");
	}

	function footer(&$field) {
		if($this->_config->poweredBy) {
			$field['output_script'] .= "<div style=\"font-size:6px;float:right;\">Powered by <a href=\"http://www.toolsjx.com/\">Tools JX</a></div>";
		}

		//$output = '<div id="data_listings'.$this->_ID.'">'.$field['output_script'].'</div>';
		$output = '<noscript>For proper performance enable JavaScript. Pages:';
// 		$output .="&nbsp;<a href=\"$grid_url&p=0\">1</a>";
// 		for($i=1; $i<$field['total_pages']; $i++) {
// 			$output .=",&nbsp;<a href=\"$grid_url&p=$i\">".(1+$i)."</a>";
// 		}
		$output .='<br>Powered by <a href=\"http://www.toolsjx.com/\">Tools JX</a>.</noscript>';

// 		if ("$this->isAjax"=="1") {
// 			header("Content-Type: text/css; charset=utf-8");
// 			echo $field['output_script'];
// 			exit;
// 		}

		return $output;
	}

	function addDiv(&$field, $graphConfig) {
		//echo $this->_ID;
		if($this->_config->showTitle)
			$field["output_script"].="<span class=\"grid_title \">".$this->_config->tableCaption."</span>";
		
//		$field["output_script"].='<script type="text/javascript" src="components/com_grid/js/flot/jquery.flot.js" ></script>';
		$field["output_script"].="<div id=\"".$this->_ID."\" style=\"width: ".$graphConfig->size->x."px; height: ".$graphConfig->size->y."px;\">Loading ...</div>";
		$field["output_script"].="<div id=\"tempDiv\"></div>";
// 		echo $field["output_script"];

	}

	function addJS($document, $graphConfig, $browser) {
		$i=0;
		foreach ($this->_config->columns as $col) {
			$columns[$col->columnName]=$col->columnLabel;
			$moreConfig[$col->columnName]=$col->moreConfig;
		}
		if($graphConfig->method=="0" && $graphConfig->refresh!="0") {
			$js="$( document ).ready(function() {";
			$js.="drawGraphDynamic('".JURI::root()."index.php?option=com_grid&gid=$this->_ID&ajax=1',
			'".$this->_config->tableName."', '".json_encode($columns)."', '".json_encode($moreConfig)."',
			'".json_encode($graphConfig)."', '#".$this->_ID."', '".$graphConfig->refresh."', '".
			htmlspecialchars($this->_config->whereCond, ENT_QUOTES).
			"', '".json_encode($this->_config->default_order)."');";
			$js.="});";
		} else {	
			//V IE 9 druga�e ne izri�e, �e ni v setInterval funkciji (kot je "live" graf)		
			if($browser->getBrowser()=="msie" && (int)$browser->getVersion()==9) {
				$js="drawGraphFixIE('".JURI::root()."index.php?option=com_grid&gid=$this->_ID&ajax=1',
			'".$this->_config->tableName."', '".json_encode($columns)."', '".json_encode($moreConfig)."',
			'".json_encode($graphConfig)."', '#".$this->_ID."', '".htmlspecialchars($this->_config->whereCond, ENT_QUOTES).
			"', '".json_encode($this->_config->default_order)."');";
			} else {
				$js="$( document ).ready(function() {";
				$js.="drawGraphFix('".JURI::root()."index.php?option=com_grid&gid=$this->_ID&ajax=1',
			'".$this->_config->tableName."', '".json_encode($columns)."', '".json_encode($moreConfig)."',
			'".json_encode($graphConfig)."', '#".$this->_ID."', '".htmlspecialchars($this->_config->whereCond, ENT_QUOTES).
			"', '".json_encode($this->_config->default_order)."');";
				$js.="});";
			}
		}
		$document->addScriptDeclaration($js);

	}

	function build() {
		
		$graphConfig=json_decode($this->_config->graphConfig);
		
		if ("$this->isAjax"=="1") {
			foreach ($this->_config->columns as $col) {
				$captions[$col->columnName]=$col->columnLabel;
				$moreConfig[$col->columnName]=$col->moreConfig;
			}
			$table=$this->_config->tableName;
			$orderBy=$this->_config->default_order;
			$db=$this->dbo;
			require_once JPATH_ROOT.'/components/com_grid/layouts/DataGraph.php';
			exit;
		}
			
		jimport('joomla.environment.browser');
		$document = JFactory::getDocument();
		$browser = JBrowser::getInstance();

		$this->includeJS($document, $browser);

		
		//echo "<pre>".print_r($graphConfig, true).'</pre>';

		$field['output_script'] ="";
		$this->addDiv($field, $graphConfig);

		$output=$this->footer($field);
		
		$this->addJS($document, $graphConfig, $browser);

		return $field['output_script'].$output;

	}


}
?>