<?php
use Joomla\CMS\Factory;
use Joomla\CMS\Installer\Installer;

defined('_JEXEC') or die;

class com_gridInstallerScript
{
    private $app, $db;

    public function __construct() {
        $this->db = Factory::getContainer()->get('db');
        $this->app = Factory::getApplication();
    }

    public function install($parent) {
        $this->update();
    }

    public function uninstall($parent) {
        $this->removePlugins();
    }

    public function preflight($type, $parent) {
        if ($type == 'uninstall') {
            $this->removePlugins();
        }
    }

    public function update() {
        $installer = Installer::getInstance();
        $path = $installer->getPath('source');
        $this->app->enqueueMessage("Component 'com_grid' has been installed.", 'message');

        InstallationOfPluginsGrid::install($path . '/plgx_insertgrid', 'Insert Grid: ');
        InstallationOfPluginsGrid::install($path . '/plgx_displaygrid', 'Display Grid: ');

    }

    private function removePlugins() {
        $this->rrmdir(JPATH_PLUGINS . '/content/displaygrid');
        $this->rrmdir(JPATH_PLUGINS . '/editors-xtd/insertgrid');

        $this->db->setQuery("DELETE FROM #__extensions WHERE `type` = 'plugin' AND (element = 'displaygrid' OR element = 'insertgrid') ");
        $this->db->execute();

        $this->app->enqueueMessage("Plugins removed");
    }

    private function rrmdir($dir) {
        if (!is_dir($dir)) {
            return;
        }

        $objects = scandir($dir);
        foreach ($objects as $object) {
            if ($object != "." && $object != "..") {
                if (filetype($dir . "/" . $object) == "dir") rrmdir($dir . "/" . $object); else unlink($dir . "/" . $object);
            }
        }
        reset($objects);
        rmdir($dir);
    }
}
class InstallationOfPluginsGrid
{
    public static function install($p_dir, $txt) {
        $app = JFactory::getApplication();
        $p_dir = JPath::clean($p_dir);

        // Did you give us a valid directory?
        if (!is_dir($p_dir)) {
            JFactory::getApplication()->enqueueMessage('SOME_ERROR_CODE', JText::_('Package directory is not correct: ' . $p_dir));
            echo JText::_('Please enter a package directory');
            return false;
        }

        // Detect the package type
        $type = JInstallerHelper::detectType($p_dir);

        // Did you give us a valid package?
        if (!$type) {
            JFactory::getApplication()->enqueueMessage('SOME_ERROR_CODE', JText::_('Path does not have a valid package: ' . $p_dir));
            echo JText::_('Path does not have a valid package: ' . $p_dir);

            return false;
        }

        $package['packagefile'] = null;
        $package['extractdir'] = null;
        $package['dir'] = $p_dir;
        $package['type'] = $type;


        // Was the package unpacked?

        if (!$package) {
            echo 'Unable to find install package';
            return false;
        }

        // Get a database connector
        //$db = & JFactory::getDBO();

        // Get an installer instance
        $installer = new JInstaller();

        // Install the package
        if (!$installer->update($package['dir'])) {
            // There was an error installing the package
            $msg = "There was an error installing the plugin";
            $app->enqueueMessage($txt . $msg, 'error');
            $result = false;
        } else {
            // Package installed sucessfully
            $msg = "Installation was successful";
            $app->enqueueMessage($txt . $msg, 'message');
            $result = true;
        }
        

        return $result;
    }
}
